Bug Hunting Session
Bug 107918 - UI - Insert mode status activation and display
Summary: UI - Insert mode status activation and display
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
5.3.3.2 release
Hardware: x86-64 (AMD64) Mac OS X (All)
: medium normal
Assignee: Heiko Tietze
URL:
Whiteboard: target:6.3.0
Keywords: difficultyBeginner, easyHack, needsUXEval, skillDesign, topicUI
Depends on:
Blocks:
 
Reported: 2017-05-17 18:13 UTC by Joop Lanting
Modified: 2019-02-20 14:31 UTC (History)
4 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Joop Lanting 2017-05-17 18:13:08 UTC
In order to toggle between INSERT mode and OVERWRITE mode the Insert key is listed (for Microsoft). Such a key does not exist on the Mac keyboard.
Please provide another keystroke for macOS (Sierra).

Additionally: the Status bar shows nothing for INSERT mode; please have that word
put there, because when blank, the proper field in the Status bar is impossible
to see, let alone to click.
Thanks.
;JOOP!
Comment 1 Alex Thurgood 2017-05-18 08:13:36 UTC
Confirming with


Version: 5.4.0.0.alpha1+
Build ID: 5ac9c1ce61c516800cef503662d80d92394fb3f9
CPU threads: 2; OS: Mac OS X 10.12.4; UI render: default; 
Locale: fr-FR (fr_FR.UTF-8); Calc: group
Comment 2 Joop Lanting 2018-03-19 07:40:54 UTC
Version 6.0.2 and still not solved.
;JOOP!
Comment 3 Xisco Faulí 2019-01-23 12:42:05 UTC
@Heiko, I thought you might be interested in this issue...
Comment 4 Heiko Tietze 2019-01-30 17:34:17 UTC
Apple has no Insert key and apparently no overtype mode. Microsoft provides an option in a configuration dialog to toggle insert/override. 

We could implement a key additional to KEY_INSERT at editeng.cxx #1259. Checking the world wide wisdom I'd say FN+Enter is the most often cited variant (FN+backspace is the common delete, so it's somewhat natural). However, this key would be hard-coded and wont be customizable. And to raise the difficulty we do not have a function key defined yet (think it's possible when we restrict it to macOS).

(Adding UX although it's a qualified easyhack to gather input. If a volunteer wants to take this we can just go ahead.)
Comment 5 Joop Lanting 2019-01-30 17:54:42 UTC
I would suggest to take advantage of the CMD key rather, as it is quite
common on macOS. So it could be CMD/Enter to toggle.

   /** (non-Javadoc)
    * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
    * @param a action event.
    */
   @Override
   public void actionPerformed(ActionEvent a)
   {
      Object o = a.getSource();
      int m = a.getModifiers();
      boolean metaPressed = (m & ActionEvent.META_MASK) != 0; // Defined in ActionEvent.java

...........

      if(o == ENTER_KEY)
      {
         if(metaPressed)
         {
            toggleOverstrike();  // Or such

Btw.: I think that showing the overstrike status has priority,
as we can use the mouse already.
;JOOP!
Comment 6 Heiko Tietze 2019-01-30 17:59:00 UTC
(In reply to Joop Lanting from comment #5)
> I would suggest to take advantage of the CMD key rather, as it is quite
> common on macOS. So it could be CMD/Enter to toggle.

Cmd+Enter is used for manual page break. And I'd be careful with those easy to enable keys as users might press it accidentally not knowing how to get back.
Comment 7 Joop Lanting 2019-01-30 18:50:04 UTC
You may be right. Well, in ECLIPSE it is Ctrl+CMD+O.
And .... I'll be just happy with the word "Insert" down below.
Remember that the word "Overwrite" shows there already.
;JOOP!
Comment 8 Heiko Tietze 2019-01-31 11:33:09 UTC
I asked a couple of people at the LibreOffice hackfest and none uses the overwrite mode. There is a tendency to refuse the shortcut but we better run a poll to have this decision based on a larger number of macOS users. Here it is https://design.blog.documentfoundation.org/2019/01/31/overwrite-on-macos/
Comment 9 Joop Lanting 2019-01-31 11:45:58 UTC
OK, I give in: drop the shortcut; please make the status (Insert/Overwrite)
visible.
;JOOP!
Comment 10 Heiko Tietze 2019-02-20 08:32:09 UTC
Patch at https://gerrit.libreoffice.org/#/c/68065/
Comment 11 Commit Notification 2019-02-20 13:16:18 UTC
heiko tietze committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/+/6e41367798d4341d601069005ae6ff6ac032f81f%5E%21

Resolves tdf#107918 - Insert mode status activation and display

It will be available in 6.3.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.